﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim DBFilePath = File.DirDefaultExternal, DBFileName = "lszamla.db" As String
	Dim sql,sql1 As SQL
	Public RTP As RuntimePermissions
End Sub



Public Sub init
	DBFilePath = RTP.GetSafeDirDefaultExternal("")
	Try
		initdb
	Catch
		Log(LastException)
	End Try
End Sub

'adatbázis előkészítése, táblaellenőrzés
Sub initdb
	Log("Initdb")
	'sql adatbázis létrehozása vagy megnyitása - titkosított, vagy normál
	Try
		sql1.Initialize(DBFilePath, DBFileName, Not(File.Exists(DBFilePath, DBFileName)))
		TableCheck		
		sql.Initialize(DBFilePath, DBFileName, False)
	Catch
		Log(LastException.Message)
	End Try
	'*****************************************************************************
	'Itt egyszer beállítom a dátumformátumot a datetime számára, mert az mindig
	'dd/MM/yyyy. ezt vehetem majd a tablet beállításaiból is, de mindenképpen úgy
	'kell beállítani, hogy a delphi is megismerje mindig mint dátumot!!!
	'ezt csak üres indításkor tehetem be, különben a létező formátumok miatt kiakad
	'egyéb ok: az sqlite csak a lenti formában ismeri fel a dátumokat!
	'*****************************************************************************
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
End Sub

'a létező verzióim módosítására, hogy ne kelljen kézzel módosítanom struktúrát
'ezt talán majd egyszer szövegállományba teszem...
Sub TableCheck
	Dim dbversion As String = sql1.ExecQuerySingleResult("PRAGMA user_version")
	Try
		If dbversion < "1" Then
			'kulcskártya adat kell a bekosarazáskor is
			Try
				sql1.ExecNonQuery($"
				CREATE TABLE cikkt
				(
				  id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
				  cikkszam NVARCHAR (50) UNIQUE,
				  megnevezes NVARCHAR (200) NOT NULL,
				  vtsz  NVARCHAR (200),
				  me  NVARCHAR (50) NOT NULL,
				  eladar NUMERIC (10, 2) NOT NULL,
				  afakod NVARCHAR(8) NOT NULL,
				  megjegyzes TEXT,
    			  umdate  DATETIME DEFAULT (datetime(CURRENT_TIMESTAMP, 'localtime'))
				)				
				"$)
				sql1.ExecNonQuery("PRAGMA user_version=1;") 'ezzel mar keszen van
			Catch
				Log(LastException.Message)
			End Try
		End If		
		If dbversion < "2" Then 
			Try
				sql1.ExecNonQuery($"
					CREATE TABLE vevot
					(
					  id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
					  vevokod  NVARCHAR (30) UNIQUE,
					  nev  NVARCHAR (200) NOT NULL,
					  adoszam  NVARCHAR (20),
					  euadoszam  NVARCHAR (20),
					  adoalany NVARCHAR (1),
					  orszag  NVARCHAR (2) default('HU'),
					  varos NVARCHAR (100) NOT NULL,
					  irsz NVARCHAR (6),
					  cim  NVARCHAR (200) NOT NULL,
					  hazszam  NVARCHAR (30),
					  epulet  NVARCHAR (10),
					  lepcsohaz NVARCHAR (10),
					  emelet NVARCHAR (10),
					  ajto NVARCHAR (10),
    			  	  umdate  DATETIME DEFAULT (datetime(CURRENT_TIMESTAMP, 'localtime'))
					)				
				"$)
				sql1.ExecNonQuery("PRAGMA user_version=2;")
			Catch
				Log(LastException)
			End Try
		End If
		'ez a jó default:
		'(datetime(CURRENT_TIMESTAMP, 'localtime''
	Catch
		Log(LastException.Message)
	End Try
End Sub

'paraméterként kapott string tömbből list-et készít és ad vissza
Sub createList( par() As String) As List
	Dim res As List
	res.Initialize
	For i = 0 To par.Length-1
		res.Add(par(i))
	Next
	Return res
End Sub
'egy stringben minden szó első betűjét nagybetűssé alakítja, 
'kivétellista is van
'ToTitleCase("are you ok brother?",Null)
'ToTitleCase("mr erel is a good person",Array As String("is","a"))
Sub ToTitleCase (str As String, exclude As List) As String
	Dim s As String
	Dim NewS() As String = Regex.Split(" ",str.Trim)
	For i = 0 To NewS.Length -1
		If (exclude.IsInitialized And exclude.IndexOf(NewS(i)) <> -1)  Then
			s = s & NewS(i)
		Else
			If NewS(i).Length > 1 Then
				s = s & NewS(i).SubString2(0,1).ToUpperCase & NewS(i).SubString(1)
			Else
				s = s & NewS(i).ToUpperCase
			End If
		End If
		If i < NewS.Length -1 Then 
			s = s & " "
		End If
	Next
	' Log(s)
	Return s
End Sub