﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Type ItemData (id As Int, Cikkszam As String, Megnevezes As String, Eladar As String, afa As String)

	Private XUI As XUI
	Private CS As CSBuilder

	Private CLVItemList As CustomListView
	Private LblAFA As B4XView
	Private LblCikkszam As B4XView
	Private LblEladar As B4XView
	Private LblMegnevezes As B4XView
	Private btnUjtermek As B4XView
	Private btnVissza As B4XView
	Private txtsfilter As B4XView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("torzsektermeklista")
End Sub

Sub Activity_Resume
	PopulateInvList
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	txtsfilter.Text = ""
End Sub

Sub PopulateInvList
	CLVItemList.sv.Visible = False 
	Wait For (FilterSearch("")) Complete (Completed As Boolean)
	CLVItemList.sv.Visible = True
End Sub

Sub CLVItemList_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 25 'List size
	For i = Max(0, FirstIndex - ExtraSize) To Min(LastIndex + ExtraSize, CLVItemList.Size - 1)
		Dim Pnl As B4XView = CLVItemList.GetPanel(i)
		If i > FirstIndex - ExtraSize And i < LastIndex + ExtraSize Then
			If Pnl.NumberOfViews = 0 Then 'Add each item/layout to the list/main layout
				Dim ID As ItemData = CLVItemList.GetValue(i)
				Pnl.LoadLayout("cikkInfo")
				LblCikkszam.Text = ID.cikkszam
				LblMegnevezes.Text = ID.megnevezes
				LblEladar.Text = ID.eladar
				LblAFA.Text = ID.afa
			End If
		Else 'Not visible
			If Pnl.NumberOfViews > 0 Then
				Pnl.RemoveAllViews 'Remove none visable item/layouts from the list/main layout
			End If
		End If
	Next
End Sub

Sub CLVItemList_ItemClick (Index As Int, Value As Object)
	Dim ID As ItemData = Value 
	TorzsekTermekKarbantarto.cikkid = ID.id
	StartActivity("torzsektermekkarbantarto")
	Log($"${ID} "$)
End Sub

Sub txtsfilter_textchanged (Old As String, New As String)
	CLVItemList.sv.Visible = False 
	FilterSearch(New)
End Sub

Sub FilterSearch (New As String) As ResumableSub
	CLVItemList.Clear
	'Sleep(0)

	Dim SenderFilter As Object
	If New.Length = 0  Then
		SenderFilter = Codebase.sql.ExecQueryAsync("SQL", $"
			SELECT `id`,`cikkszam`,  
			`megnevezes`, 
			(eladar || " /" || me) AS `eladar`,
			`afakod` 
			FROM `cikkt` ORDER BY `megnevezes` ASC LIMIT 2000;"$, Null) 'I NO NOT RECOMMEND that you load the whole database
	Else
		SenderFilter = Codebase.sql.ExecQueryAsync("SQL", $"
			SELECT 
			`id`,`cikkszam`,  
			`megnevezes`, 
			(eladar || " /" || me) AS `eladar`,
			`afakod`
			FROM `cikkt` 
			WHERE (megnevezes) Like '%${New}%'
			ORDER BY `megnevezes` ASC LIMIT 500;"$, Null) 'Limited for slower devices
	End If

	Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, rs As ResultSet)
	If Success Then

		Do While rs.NextRow
			Dim ID As ItemData
			ID.Initialize
			ID.Cikkszam = rs.GetString("cikkszam")
			ID.Megnevezes = rs.GetString("megnevezes")
			ID.Eladar = rs.GetString("eladar")
			ID.afa = $"${rs.GetString("afakod")}"$
			ID.id = $"${rs.Getint("id")}"$
		
			Dim Pnl As B4XView = XUI.CreatePanel("")
			Pnl.SetLayoutAnimated(0, 0, 0, CLVItemList.AsView.Width, 50dip)
			CLVItemList.Add(Pnl, ID)
		Loop
		rs.Close
	Else
		Log(LastException)
	End If

	'Add an icon to the activity text by using CSBuilder
	Activity.Title = CS.Initialize.Typeface(Typeface.FONTAWESOME).Append(Chr(0xF15C)).Append($" ${CLVItemList.Size} Termékeim"$).PopAll
	
	CLVItemList.sv.Visible = True
	Return True
End Sub

Sub btnVissza_Click
	Activity.Finish
End Sub

Sub btnUjtermek_Click
	TorzsekTermekKarbantarto.cikkid = -1
	StartActivity("torzsektermekkarbantarto")
End Sub
